print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libMCLAR.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("MCLAR", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")


srand()

beat = 3
base = 8.00
rbase = base - 1.00
amp = 1800
env = maketable("line", 1000, 0,1, 99,1, 100,0)

load_array(1, 1.00, 1.02, 1.00, 1.00, 1.00, 1.00, 1.00, 0.07, 1.00, 1.00, 1.02, 1.00)
load_array(2, 1.07, 2.07, 1.07, 1.05, 1.07, 1.05, 1.07, 1.02, 1.07, 1.07, 1.07, 1.07)
load_array(3, 2.00, 0.07, 2.02, 2.00, 2.00, 2.05, 2.02, 1.07, 2.04, 2.00, 0.07, 0.00)
load_array(4, 12,   6,    6,    6,    6,    6,    6,    6,    6,    3,    3,  10)
load_array(5, 2.02, 1.09, 1.04, 1.09, 2.04, 1.07, 1.04, 1.11, 2.07, 1.02, 2.02, 2.00)

nnotes = get_size(1)

st = 0.0
for (i = 0; i < nnotes; i += 1) {
	dur = get_array(4, i) * beat
	rdur = dur + (beat * 0.3)

	pitch = cpspch(rbase + get_array(1, i))
	MCLAR(st, rdur, amp*env, pitch, irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 0.0)
	MCLAR(st, rdur, amp*env, pitch+irand(-1, 1), irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 1.0)

	pitch = cpspch(rbase + get_array(2, i))
	MCLAR(st, rdur, amp*env, pitch, irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 1.0)
	MCLAR(st, rdur, amp*env, pitch+irand(-1, 1), irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 0.0)

	if (random() > 0.5) {
		pitch = cpspch(rbase + get_array(3, i))
		MCLAR(st, rdur, amp*env, pitch, irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 0.0)
		MCLAR(st, rdur, amp*env, pitch+irand(-1, 1), irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 1.0)
	}

	if (random() > 0.5) {
		pitch = cpspch(rbase + get_array(5, i))
		MCLAR(st, rdur, amp*env, pitch, irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 0.0)
		MCLAR(st, rdur, amp*env, pitch+irand(-1, 1), irand(0.0, 0.4), irand(0.3, 0.7), irand(0.3, 0.7), 1.0)
	}

	st += dur
}


st += 15
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 1.0, 0)

MIX(0, 0, st, 1, 0, 1)

