print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("WAVETABLE", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()


beat = 3
base = 8.00
rbase = base - 3.00
amp = 4800
env = maketable("line", 1000, 0,0, 1,1, 3,0)

padd = { 0.00, 0.00, 0.04, 0.07, 0.07, 1.00, 1.00, 1.02, 1.02, 1.04, 1.04, 1.07, 1.07, 2.00, 2.00, 2.02, 2.04, 2.07, 3.00, 3.02, 3.04, 3.07, 4.00, 4.02, 4.04, 4.07 }
pvar = 1

load_array(1, 1.00, 1.07, 1.00, 1.05, 1.00, 1.05, 1.00, 0.07, 1.00, 1.00, 0.05, 0.00)
load_array(2, 12,   6,    6,    6,    6,    6,    6,    6,    6,    3,    3,  10)

nnotes = get_size(1)

st = 0.0
step = beat/2
for (i = 0; i < nnotes; i += 1) {
	dur = get_array(2, i) * beat
	wave = maketable("wave", 1000, 1, random(), random())
	bpitch = rbase + get_array(1, i)

	for (j = 0; j < dur; j += step) {
		index = trunc(irand(0, len(padd)))
		pitch = cpspch(bpitch + padd[index])
		WAVETABLE(st+j, 4*step, amp*env, pitch + irand(-pvar, pvar), 0.1, wave)
		WAVETABLE(st+j, 4*step, amp*env, pitch + irand(-pvar, pvar), 0.2, wave)
		WAVETABLE(st+j, 4*step, amp*env, pitch + irand(-pvar, pvar), 0.8, wave)
		WAVETABLE(st+j, 4*step, amp*env, pitch + irand(-pvar, pvar), 0.9, wave)
	}
	st += dur
}


st += 15
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 1.0, 0)

MIX(0, 0, st, 1, 0, 1)

