print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libMBLOWBOTL.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("MBLOWBOTL", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 3
base = 8.00
rbase = base - 1.00
amp = 55000
env = maketable("line", 1000, 0,0, 1,1, 7,1, 10,0)

load_array(1, 0.00, 0.07, 0.00, 0.05, 0.00, 0.05, 0.00, 0.07, 0.00, 0.00, 0.07, 0.00)
load_array(2, 12,   6,    6,    6,    6,    6,    6,    6,    6,    3,    3,  10)

nnotes = get_size(1)

tvar = beat/3
st = 0.0
for (i = 0; i < nnotes; i += 1) {
	dur = get_array(2, i) * beat
	rdur = beat*2

	pitch = rbase + get_array(1, i)

	for (j = 0; j < dur; j += beat) {
		if (random() > 0.35) {
			rpitch = pitch
			dice = random()
			if (dice > 0.33) rpitch += 0.07
			if (dice > 0.66) rpitch += 0.05

			MBLOWBOTL(st+j+irand(0, tvar), rdur, amp*env, cpspch(rpitch), irand(0.01, 0.2), irand(0.3, 0.7), random())
		}
	}

	st += dur
}


st += 15
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 1.0, 0)

MIX(0, 0, st, 1, 0, 1)

