print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libSTRUMFB.so")
load("./RTcmix/libs/libJDELAY.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("STRUMFB", "aux 0-1 out")
bus_config("JDELAY", "aux 0-1 in", "aux 2-3 out")
bus_config("SPLITTER", "aux 2-3 in", "aux 4-5 out", "aux 6-7 out")
bus_config("MIX", "aux 4-5 in", "out 0-1")
bus_config("FLANGE", "aux 6-7 in", "aux 8-9 out")
bus_config("PANECHO", "aux 8-9 in", "out 0-1")

srand()


beat = 1
amp = 24000
ampenv = maketable("line", 1000, 0,0, 2,1, 8,1, 10,0)

bases = { 5.00, 6.00, 7.00, 8.00, 9.00 }

durs = {  1,    1,    1,    1,    2,    2,    2,    2,
   1,    1,    1,    1,    2,    2,    4,
   1,    1,    1,    1,    2,    2,    2,    2,
   1,    1,    1,    1,    2,    2,    4 }
ndurs = len(durs)

tdur = 0 
for (i = 0; i < ndurs; i += 1) tdur += durs[i]
tdur *= beat
// do the whole thing 2X
tdur *= 2

JDELAY(0, 0, tdur, 1, 0.35, 0.8, 5, 1000, 1)

st = irand(0, 8*beat)
while (st < tdur) {
	base = bases[trand(0, len(bases))]
	dur = irand(7*beat, 14*beat)

	vib = makeLFO("sine", irand(2, 5), 0, 0.002)
	feedback_freq = makerandom("even", 2*beat, 50, 1000)
	STRUMFB(st, dur, amp*ampenv, base+vib, feedback_freq, 2, dur, dur, 0.1, 0.15, 0, 1, 0.5)

	st = st + irand(5*beat, 15*beat) + dur
}

// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 10.0, 0)

MIX(0, 0, st, 1, 0, 1)

