print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("WAVETABLE", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 1
base = 7.00

amp = 3000

chord1 = { 3.07, 3.02, 3.00, 2.07, 2.04, 2.02, 2.00, 1.07, 1.02, 1.00, 0.07, 0.00 }
lench1 = len(chord1)
chord2 = { 3.07, 3.05, 3.02, 3.00, 2.09, 2.07, 2.04, 2.02, 2.00, 1.05, 1.07, 1.00, 0.05, 0.00 }
lench2 = len(chord2)
chord3 = { 3.07, 3.02, 3.00, 2.11, 2.09, 2.07, 2.04, 2.02, 2.00, 1.07, 1.04, 1.02, 1.00, 0.07, 0.00 }
lench3 = len(chord3)
chord4 = { 3.07, 3.02, 3.00,  2.07, 2.02, 2.00, 1.07, 1.02, 1.00, 0.07, 0.00 }
lench4 = len(chord4)

durs = {  1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4,
	1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4 }
ndurs = len(durs)

tdur = 0
for (i = 0; i < ndurs; i += 1) tdur += durs[i]
tdur *= beat
// do the whole thing 2X
tdur *= 2

ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
wave = maketable("wave", 1000, 1, 0.2, 0.1)


notedur = 1.5
notetime = 0.19
st = irand(0, 5*beat)
while (st < tdur) {

	dice = random()
	if (dice < 0.25) lench = lench1
	else if (dice < 0.5) lench = lench2
	else if (dice < 0.75) lench = lench3
	else lench = lench4

	offset = 0
	for (i = 0; i < lench; i += 1) {
		if (dice < 0.25) pitch = base +chord1[i]
		else if (dice < 0.5) pitch = base +chord2[i]
		else if (dice < 0.75) pitch = base +chord3[i]
		else pitch = base +chord4[i]

		WAVETABLE(st+offset, notedur, amp*ampenv, pitch, 0, wave)
		WAVETABLE(st+offset, notedur, amp*ampenv, pitch+irand(0, 0.0011), 0.2, wave)
		WAVETABLE(st+offset, notedur, amp*ampenv, pitch+irand(0, 0.0011), 0.8, wave)
		WAVETABLE(st+offset, notedur, amp*ampenv, pitch+irand(0, 0.0011), 1, wave)
		offset += notetime
	}

	st += irand(8*beat, 15*beat)
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 10.0, 0)

MIX(0, 0, st, 1, 0, 1)

