print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libSTRUM2.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("STRUM2", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 1
base = 6.00

amp = 30000

chord = { 0.00, 0.07, 1.00, 1.07, 2.00, 2.07, 3.00 }
lchord = len(chord)
notes = { 0.00, 0.00, 0.00, 0.00, 0.00, 0.07, 0.00, 0.05, 0.00, 0.07, 0.00 }
durs = {  4,    4,    4,    4,    4,    4,    8,    4,    6,    2,    4 }

nnotes = len(notes)

st = 0
cincr = 0.1
for (ii = 0; ii < 2; ii += 1) {
	for (i = 0; i < nnotes; i += 1) {
		pitch = base + notes[i]
		dur = durs[i]*beat

		offset = 0
		for (j = 0; j < lchord; j += 1) {
			STRUM2(st+offset, dur, amp, pitch+chord[j], 6, dur, j/lchord)
			offset += irand(0, cincr)
		}

		st += dur
	}
}


st = st + dur
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 10.0, 0)

MIX(0, 0, st, 1, 0, 1)

