print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libIIR.so")
load("./RTcmix/libs/libAM.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("PULSE", "aux 0-1 out")
bus_config("AM", "aux 0 in", "aux 2-3 out")
bus_config("STEREO", "aux 1 in", "aux 2-3 out")
bus_config("SPLITTER", "aux 2-3 in", "aux 4-5 out", "aux 6-7 out")
bus_config("MIX", "aux 4-5 in", "out 0-1")
bus_config("FLANGE", "aux 6-7 in", "aux 8-9 out")
bus_config("PANECHO", "aux 8-9 in", "out 0-1")


srand()

beat = 0.5
base = 7.00

amp = 50000
ampenv = maketable("line", 1000, 0,0, 3,1, 7,1, 10,0)

notes = { 0.04, 0.07, 0.09 }
nnotes = len(notes)
durs = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1 }

tdur = 0
for (i = 0; i < len(durs); i += 1) tdur += durs[i]
tdur *= beat
// do it 2X
tdur *= 2

amwave = maketable("wave", 1000, "sine")
amamp = maketable("line", 1000, 0,0, 1,1, 2,0)
AM(0, 0, tdur, 1*amamp, irand(5, 9), 0, 0.5, amwave)

stamp = maketable("line", 1000, 0,1, 1,irand(0, 0.3), 2,1)
STEREO(0, 0, tdur, 1*stamp, 0.5)

setup(irand(1000, 3000), 1000, 1)
for (i = 0; i < nnotes; i += 1) {
	pitch = base + notes[i]

	PULSE(0, tdur, amp*ampenv, pitch, random())
	PULSE(0, tdur, amp*ampenv, pitch+irand(0, 0.0017), random())
}


st = tdur
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 5.0, 0)

MIX(0, 0, st, 1, 0, 1)

