print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libFMINST.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("FMINST", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 0.5
base = 5.00

amp = 5000

notes = { 0.09, 1.04, 1.09 }
nnotes = len(notes)
durs = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1 }

tdur = 0
for (i = 0; i < len(durs); i += 1) tdur += durs[i]
tdur *= beat
// do it 2X
tdur *= 2

ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
wave = maketable("wave", 1000, 1, 0.2, 0.05)
indexenv = maketable("line", 1000, 0,0, 1,1, 2,0)

st = irand(0, tdur/4)
dur = irand(tdur/2, tdur)
for (i = 0; i < nnotes; i += 1) {
	pitch = base + notes[i]

	FMINST(st, dur, amp*ampenv, pitch, pitch, 0, 2, 0, wave, indexenv)
	FMINST(st, dur, amp*ampenv, pitch+irand(0, 0.0017), pitch, 0, 2, 1, wave, indexenv)

}

st = st + dur
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 5.0, 0)

MIX(0, 0, st, 1, 0, 1)

