print_off()
rtsetparams(44100, 2)

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libMMODALBAR.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("WAVETABLE", "aux 0-1 out")
bus_config("MMODALBAR", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 3
base = 8.00
amp = maketable("line", 1000, 0,0, 1,1, 2,0)
wave = maketable("wave", 1000, 1, 0.2, 0.1)

load_array(1, 1.07, 1.09, 1.07, 1.04, 1.07, 1.09, 1.07, 1.04, 1.14, 1.14, 1.11, 1.12, 1.12, 1.07,  1.09, 1.09, 1.12, 1.11, 1.09, 1.07, 1.09, 1.07, 1.04,  1.09, 1.09, 1.12, 1.11, 1.09, 1.07, 1.09, 1.07, 1.04,  1.14, 1.14, 1.17, 1.14, 1.11, 1.12, 1.16,  1.12, 1.07, 1.04, 1.07, 1.05, 1.02, 1.00)
load_array(2, 1,    1,    1,    3,    1,    1,    1,    3,    2,    1,    3,    2,    1,    3,     2,    1,    1,    1,    1,    1,    1,    1,    3,     2,    1,    1,    1,    1,    1,    1,    1,    3,     2,    1,    1,    1,    1,    3,    3,     1,    1,    1,    1,    1,    1,    6)

nnotes = get_size(1)

st = 0.0
for (i = 0; i < nnotes; i += 1) {
	pitch = cpspch(base + get_array(1, i))
	dur = get_array(2, i) * beat
	rdur = dur + (beat * 0.5)
	MMODALBAR(st, rdur, 200000*amp, pitch, irand(0.1, 0.9), irand(0.1, 0.9), 1, 0.3)
	MMODALBAR(st, rdur, 200000*amp, pitch+irand(-2, 2), irand(0.1, 0.9), irand(0.1, 0.9), 1, 0.7)
	WAVETABLE(st, rdur, 5000*amp, pitch+irand(-2, 2), 0.2, wave)
	WAVETABLE(st, rdur, 5000*amp, pitch+irand(-2, 2), 0.8, wave)

	st += dur
}


st += dur
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 1.0, 0)

MIX(0, 0, st, 1, 0, 1)
