print_off()
rtsetparams(44100, 2)

load("./RTcmix/libs/libSTRUM.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("START", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 3
base = 8.00
makegen(1, 24, 1000, 0,0, 1,1, 5,1, 5.5,0)
amp = 90000

load_array(1, 0.07, 0.09, 0.07, 0.04, 0.07, 0.09, 0.07, 0.04, 0.14, 0.14, 0.11, 0.12, 0.12, 0.07,  0.09, 0.09, 0.12, 0.11, 0.09, 0.07, 0.09, 0.07, 0.04,  0.09, 0.09, 0.12, 0.11, 0.09, 0.07, 0.09, 0.07, 0.04,  0.14, 0.14, 0.17, 0.14, 0.11, 0.12, 0.16,  0.12, 0.07, 0.04, 0.07, 0.05, 0.02, 0.00)
load_array(2, 1,    1,    1,    3,    1,    1,    1,    3,    2,    1,    3,    2,    1,    3,     2,    1,    1,    1,    1,    1,    1,    1,    3,     2,    1,    1,    1,    1,    1,    1,    1,    3,     2,    1,    1,    1,    1,    3,    3,     1,    1,    1,    1,    1,    1,    6)

nnotes = get_size(1)

st = 0.0
pvar = 3
sq = 2
for (i = 0; i < nnotes; i += 1) {
	pitch = cpspch(base + get_array(1, i))
	dur = get_array(2, i) * beat
	rdur = 2.5*dur

	START(st, rdur, pchcps(pitch + irand(-pvar, pvar)), rdur, rdur/2, amp, sq, 0.0)
	START(st, rdur, pchcps(pitch + irand(-pvar, pvar)), rdur, rdur/2, amp, sq, 1.0)
	START(st, rdur, 1.0+pchcps(pitch + irand(-pvar, pvar)), rdur, rdur/2, 0.5*amp, sq, 0.3)
	START(st, rdur, 1.0+pchcps(pitch + irand(-pvar, pvar)), rdur, rdur/2, 0.5*amp, sq, 0.7)


	st += dur
}


st += (dur * 0.6)
makegen(1, 24, 1000, 0,1, 1,1)
// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 1.0, 0)

MIX(0, 0, st, 1, 0, 1)


