print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("WAVETABLE", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 2
if (random() < 0.5 ) base = 8.00
else base = 7.00

amp = 20000

notes = { 1.00, 1.00, 1.00, 1.02, 1.00, 1.00, 0.07,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	1.00, 1.00, 1.00, 1.02, 1.00, 1.00, 0.07,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	1.07, 1.05, 1.04, 1.02, 1.04, 1.02, 1.00,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	0.07, 0.07, 0.09, 0.11, 1.00, 1.00, 1.02,  1.07, 1.05, 1.04, 1.02, 1.00, 1.05, 1.00 }
durs = {  1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
	1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
   1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
	1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,    4 }
nnotes = len(notes)


wave1 = maketable("wave", 1000, "sine")
wave2 = maketable("wave", 1000, "saw14")
wave3 = maketable("wave", 1000, "square14")
wave4 = maketable("wave", 1000, "buzz14")
wave5 = maketable("wave", 1000, "tri14")
wave6 = maketable("wave", 1000, random(), random(), random(), random(), random(), random(), random())
wave7 = maketable("wave", 1000, random(), random(), random(), random(), random(), random(), random())
wave8 = maketable("wave", 1000, random(), random(), random(), random(), random(), random(), random())
wave9 = maketable("wave", 1000, random(), random(), random(), random(), random(), random(), random())
wave10 = maketable("wave", 1000, random(), random(), random(), random(), random(), random(), random())

ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)

st = 0
for (i = 0; i < nnotes; i += 1) {
	pitch = base + notes[i]
	dur = durs[i] * beat

	offset = 0
	rdur = 0.2
	ampmult = 1
	while (offset < dur) {
		dice = random()
		if (dice < 0.1)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave1)
		else if (dice < 0.2)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave2)
		else if (dice < 0.3)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave3)
		else if (dice < 0.4)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave4)
		else if (dice < 0.5)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave5)
		else if (dice < 0.6)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave6)
		else if (dice < 0.7)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave7)
		else if (dice < 0.8)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave8)
		else if (dice < 0.9)
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave9)
		else 
			WAVETABLE(st+offset, rdur, amp*ampenv*ampmult, pitch, 0.5, wave10)

		offset += (rdur*0.7)
		ampmult *= 0.8
	}

	st += dur
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 10.0, 0)

MIX(0, 0, st, 1, 0, 1)

