print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libMBOWED.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("MBOWED", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 2
if (random() < 0.5) {
	base = 8.00
	pcor = 5
} else {
	base = 7.00
	pcor = 2
}

amp = 12000

notes = { 1.00, 1.00, 1.00, 1.02, 1.00, 1.00, 0.07,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	1.00, 1.00, 1.00, 1.02, 1.00, 1.00, 0.07,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	1.07, 1.05, 1.04, 1.02, 1.04, 1.02, 1.00,  0.09, 0.07, 0.09, 0.11, 1.00, 1.00,
	0.07, 0.07, 0.09, 0.11, 1.00, 1.00, 1.02,  1.07, 1.05, 1.04, 1.02, 1.00, 1.05, 1.00 }
durs = {  1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
	1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
   1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,
	1,    1,    1,    1,    1,    1,    2,     1,    1,    1,    1,    2,    2,    4 }
nnotes = len(notes)

ampenv = maketable("line", 1000, 0,0, 1,1, 9,1, 10,0)

bowvelenv = maketable("line", 1000, 0,1, 1,1, 2,0)
bowpressenv = maketable("line", 1000, 0,1, 1,1)
bowposenv = maketable("line", 1000, 0,1, 1,0)
vibtable = maketable("wave", 1000, "sine")
bowvelenv2 = maketable("line", 1000, 0,0, 1,1)

st = 0
for (i = 0; i < nnotes; i += 1) {
	pitch = base + notes[i]
	dur = durs[i] * beat

	MBOWED(st, dur, amp*ampenv, cpspch(pitch)-pcor, 2, 7, 0.005, 0, bowvelenv, bowpressenv, bowposenv, vibtable)
	MBOWED(st, dur, amp*ampenv, cpspch(pitch+irand(0.0007, 0.0011))-pcor, 1, 5, 0.005, 1, bowvelenv2, bowpressenv, bowposenv, vibtable)

	st += dur
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 15.0, 0)

MIX(0, 0, st, 1, 0, 1)

