print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libIIR.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("PULSE", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 1
amp = 15000

notes = { 1.00, 1.00, 1.00, 1.00, 1.00, 1.09, 1.07, 1.04,
	1.00, 1.00, 1.00, 1.00, 1.00, 1.09, 1.07,
	1.07, 1.05, 1.04, 1.02, 1.00, 1.04, 0.09, 0.07,
	1.00, 1.02, 1.04, 1.05, 1.04, 1.02, 1.00 }
durs = {  1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4,
	1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4 }

nnotes = len(notes)

ampenv = maketable("line", 1000, 0,0, 1,1, 7,1, 10,0)

st = 0
for (ii = 0; ii < 2; ii += 1) {
	dice = random()
	if (dice < 0.25) base = 5.00
	else if (dice < 0.5) base = 6.00
	else if (dice < 0.75) base = 7.00
	else base = 8.00

	for (i = 0; i < nnotes; i += 1) {
		pitch = base + notes[i]
		dur = durs[i]*beat

		dice = random()
		if (dice < 0.25) {
			setup(700, 400, 1, 1500, 300, 0.7, 3000, 500, 0.4)
		} else if (dice < 0.5) {
			setup(500, 400, 1, 1900, 300, 0.7, 2500, 500, 0.4)
		} else if (dice < 0.75) {
			setup(500, 400, 1, 1100, 300, 0.5, 2500, 500, 0.7)
		} else {
			setup(900, 400, 0.5, 1200, 300, 1.0, 4500, 500, 0.4)
		}

		for (j = 0; j < 5; j += 1) {
			vib = makeLFO("sine", irand(3, 6), 0.00, 0.0025)
			PULSE(st, dur, amp*ampenv, pitch+irand(0, 0.0019)+vib, random())
		}

		st += dur
	}
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 15.0, 0)

MIX(0, 0, st, 1, 0, 1)

