print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("WAVETABLE", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

reset(20000)

beat = 1
base = 7.00

amp = 10000

notes = { 1.00, 1.00, 1.00, 1.00, 1.00, 1.09, 1.07, 1.04,
	1.00, 1.00, 1.00, 1.00, 1.00, 1.09, 1.07,
	1.07, 1.05, 1.04, 1.02, 1.00, 1.04, 0.09, 0.07,
	1.00, 1.02, 1.04, 1.05, 1.04, 1.02, 1.00 }
durs = {  1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4,
	1,    1,    1,    1,    2,    2,    2,    2,
	1,    1,    1,    1,    2,    2,    4 }

nnotes = len(notes)

ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
wave = maketable("wave", 1000, 1, 0.3, 0.02)

st = 0
dev = 0.03
tdur = 0.04
toff = 0.02
for (ii = 0; ii < 2; ii += 1) {
	for (i = 0; i < nnotes; i += 1) {
		pitch = base + notes[i]
		dur = durs[i]*beat
		rdur = dur * 0.8

		tadd = 0
		while (tadd < rdur) {
			freq = cpspch(pitch)
			lfreq = freq - (dev*freq)
			hfreq = freq + (dev*freq)
			WAVETABLE(st + tadd, tdur, amp*ampenv, irand(lfreq, hfreq), random(), wave)
			tadd += irand(0, toff)
		}

		st += dur
	}
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 15.0, 0)

MIX(0, 0, st, 1, 0, 1)

