print_off()

rtsetparams(44100, 2)

load("./RTcmix/libs/libMBANDEDWG.so")
load("./RTcmix/libs/libFLANGE.so")
load("./RTcmix/libs/libPANECHO.so")
load("./RTcmix/libs/libSPLITTER.so")

bus_config("MBANDEDWG", "aux 0-1 out")
bus_config("SPLITTER", "aux 0-1 in", "aux 2-3 out", "aux 4-5 out")
bus_config("MIX", "aux 2-3 in", "out 0-1")
bus_config("FLANGE", "aux 4-5 in", "aux 6-7 out")
bus_config("PANECHO", "aux 6-7 in", "out 0-1")

srand()

beat = 0.5
base = 8.00

amp = 20000

notes = { 1.04, 0.09, 0.11, 1.04, 1.02, 0.11, 1.00, 0.09, 0.11, 1.00, 0.11, 0.09, 0.11, 1.00, 0.11, 0.09, 0.11, 1.00, 1.02,
1.04, 0.09, 0.11, 1.04, 1.02, 0.11, 1.00, 0.09, 0.11, 1.00, 0.11, 0.09, 0.11, 1.00, 0.11, 0.09,
0.11, 1.00, 1.02, 1.00, 0.04, 0.07, 1.00, 1.02, 0.07, 0.11, 1.02, 1.04, 0.09, 1.00,
1.04, 1.04, 1.04, 1.07, 1.05, 1.04, 1.02, 1.04 }
durs = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.5, 0.5, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1 }
nnotes = len(notes)

st = 0
// do it 2X
for (ii = 0; ii < 2; ii += 1) {
	dice = random()
	for (i = 0; i < nnotes; i += 1) {
		pitch = base + notes[i]
		dur = durs[i] * beat

		if (dice < 0.7)
			MBANDEDWG(st+irand(0, 0.05), dur, amp, cpspch(pitch), irand(0, 1), 1, irand(0.1, 1.0), 0, 0.0, 1.0, 0.0, random())
		if (dice > 0.3)
			MBANDEDWG(st+irand(0, 0.05), dur, amp, cpspch(pitch+1), irand(0, 1), 1, irand(0.1, 1.0), 0, 0.0, 1.0, 0.0, random())

		st += dur
	}
}


// flange + panecho
SPLITTER(0, 0, st, 1, 0, 1.2, 0, 1.4, 0)
SPLITTER(0, 0, st, 1, 1, 0, 1.2, 0, 1.4)

fwave = maketable("wave", 10000, "sine")

amp  = 0.7
c0del = irand(0.4, 0.7)
c1del = irand(0.2, 0.45)

FLANGE(0, 0, st, amp, 0.02, 0.005, 70, 0.4, 1, "iir", 0, 0.5, 1.0, fwave)

PANECHO(0, 0, st, 0.7, c0del, c1del, 0.8, 15.0, 0)

MIX(0, 0, st, 1, 0, 1)

