// hohoho2dmatic -- ambient christmas tunes, 2007
//		based on hohoho2-matic (2006), by Brad Garton
//		http://music.columbia.edu/~brad


// Global variables for the info and done buttons
var glassDoneButton;
var whiteInfoButton;

var isHoing = 0; // flag for running or stopped
var npieces = 4; // number of pieces available
var nmels = 4; // number of mels
var naccs = 4; // number of accs

var fillerproc; // proc id for filler
var fillertimer; // proc id for filler start timer

var melproc; // proc id for mel
var accproc; // proc id for acc
var musictimer; // proc id for music start timer

var snowtimer; // interval timer for snow animation
var snowX = new Array(35); // snowflake x
var snowY = new Array(35); // snowflake y

function setup()
{
	glassDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	whiteInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);

	for (var i = 0; i < snowX.length; i++) {
		snowX[i] = parseInt(Math.random() * 150);
		snowY[i] = parseInt(Math.random() * 100);
	}

	widget.onremove = hohoho2dmaticKill;
}

// showPrefs() is called when the preferences flipper (info button) is clicked
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

		snowtimer = setInterval("gocanv()", 50);
}


// hidePrefs() is called by the done button on the back side of the widget
function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front

	clearInterval(snowtimer);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// intervalTimer animation function for snow on back
function gocanv()
{
	var canvas = document.getElementById("snowcanvas");
	var context = canvas.getContext("2d");

	context.clearRect(0, 0, 150, 100);
	for (var i = 0; i < snowX.length; i ++) {
		if (Math.random() < 0.5) snowX[i] = snowX[i]+1;
		else snowX[i] = snowX[i]-1;
		snowY[i] = snowY[i]+1;

		if (snowX[i] > 145) snowX[i] = 0;
		if (snowX[i] < 0) snowX[i] = 145;
		if (snowY[i] > 100) snowY[i] = 0;

		context.strokeStyle = 'rgba(255, 255, 255, 1)';
		context.moveTo(snowX[i], snowY[i]);
		context.lineTo(snowX[i]+1, snowY[i]+1);
		context.stroke();
	}
}


// start and stop the music
function startHoing()
{
	if (isHoing == 0) { // kick it off!
		document.getElementById("hohohoButton").src = "Images/hohohol.png";
		dofiller(); // start the filler process
	} else { // shut it down!
		document.getElementById("hohohoButton").src = "Images/enoughl.png";

		if (fillerproc != null) fillerproc.cancel();
		if (fillertimer != null) clearTimeout(fillertimer);
		if (melproc != null) melproc.cancel();
		if (accproc != null) accproc.cancel();
		if (musictimer != null) clearTimeout(musictimer);
		if (snowtimer != null) clearInterval(snowtimer);
		widget.system("killall hoCMIX", donothing); // just in case...
	}
}


function hobuttonUp()
{
	if (isHoing == 0) {
		document.getElementById("hohohoButton").src = "Images/enough.png";
		isHoing = 1;
	} else {
		document.getElementById("hohohoButton").src = "Images/hohoho.png";
		isHoing = 0;
	}
}


function gohohoho2dweb() {
   document.getElementById("hohoho2dwebButton").src = "Images/hohoho2dwebl.png";
}

function hohoho2dwebUp() {
   document.getElementById("hohoho2dwebButton").src = "Images/hohoho2dweb.png";
   widget.openURL("http://music.columbia.edu/~brad/hohoho2dmatic/");
}

function gobradweb() {
   document.getElementById("bradwebButton").src = "Images/bradwebl.png";
}

function bradwebUp() {
   document.getElementById("bradwebButton").src = "Images/bradweb.png";
   widget.openURL("http://music.columbia.edu/~brad/");
}


// sound functions
function dofiller() {
	fillerproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/filler.sco", donothing);

	musictimer = setTimeout("domusic()", 35000);
}

function domusic() {
	var nextfill; // dependent on which piece/mel was chosen

	// choose a piece
	var dice = parseInt(Math.random() * npieces);
	if (dice == 0) { // piece 0
		// choose a melody version
		var dice1 = parseInt(Math.random() * nmels);
		switch(dice1) {
			case 0:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel00.sco", donothing);
				break;
			case 1:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel01.sco", donothing);
				break;
			case 2:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel02.sco", donothing);
				break;
			case 3:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel03.sco", donothing);
		}

		// choose a melody version
		var dice2 = parseInt(Math.random() * naccs);
		switch(dice2) {
			case 0:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc00.sco", donothing);
				break;
			case 1:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc01.sco", donothing);
				break;
			case 2:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc02.sco", donothing);
				break;
			case 3:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc03.sco", donothing);
		}
		nextfill = 216000;
	} // end of piece 0
	else if (dice == 1) { // piece 1
		// choose a melody version
		var dice1 = parseInt(Math.random() * nmels);
		switch(dice1) {
			case 0:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel10.sco", donothing);
				break;
			case 1:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel11.sco", donothing);
				break;
			case 2:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel12.sco", donothing);
				break;
			case 3:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel13.sco", donothing);
		}

		// choose a melody version
		var dice2 = parseInt(Math.random() * naccs);
		switch(dice2) {
			case 0:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc10.sco", donothing);
				break;
			case 1:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc11.sco", donothing);
				break;
			case 2:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc12.sco", donothing);
				break;
			case 3:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc13.sco", donothing);
		}
		nextfill = 136000;
	} // end of piece 1
	else if (dice == 2) { // piece 2
		// choose a melody version
		var dice1 = parseInt(Math.random() * nmels);
		switch(dice1) {
			case 0:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel20.sco", donothing);
				break;
			case 1:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel21.sco", donothing);
				break;
			case 2:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel22.sco", donothing);
				break;
			case 3:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel23.sco", donothing);
		}

		// choose a melody version
		var dice2 = parseInt(Math.random() * naccs);
		switch(dice2) {
			case 0:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc20.sco", donothing);
				break;
			case 1:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc21.sco", donothing);
				break;
			case 2:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc22.sco", donothing);
				break;
			case 3:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc23.sco", donothing);
		}
		nextfill = 96000;
	} // end of piece 2
	else if (dice == 3) { // piece 3
		// choose a melody version
		var dice1 = parseInt(Math.random() * nmels);
		switch(dice1) {
			case 0:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel30.sco", donothing);
				break;
			case 1:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel31.sco", donothing);
				break;
			case 2:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel32.sco", donothing);
				break;
			case 3:
				melproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/mel33.sco", donothing);
		}

		// choose a melody version
		var dice2 = parseInt(Math.random() * naccs);
		switch(dice2) {
			case 0:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc30.sco", donothing);
				break;
			case 1:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc31.sco", donothing);
				break;
			case 2:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc32.sco", donothing);
				break;
			case 3:
				accproc = widget.system("./RTcmix/hoCMIX < ./RTcmix/acc33.sco", donothing);
		}
		nextfill = 55000;
	} // end of piece 3

	fillertimer = setTimeout("dofiller()", nextfill);
}

// shut everything down if widget is removed while sound is running
function hohoho2dmaticKill()
{
      if (fillerproc != null) fillerproc.cancel();
      if (fillertimer != null) clearTimeout(fillertimer);
      if (melproc != null) melproc.cancel();
      if (accproc != null) accproc.cancel();
      if (musictimer != null) clearTimeout(musictimer);
      if (snowtimer != null) clearInterval(snowtimer);
      widget.system("killall hoCMIX", donothing); // just in case...
}

function donothing() {}

